/**
 * Jose Luis Alonzo Velazquez
 * Ejemplo de poligono girando
 * Aqui utilizamos traslaciones y rotaciones
 * Uso de la funcion idle, ademas de keyboard special
 */
#include <windows.h>
#include <GL/glut.h>
#include <stdlib.h>
#include <iostream>

using namespace std;
//Variables globales
const int W_WIDTH = 500; // Tamao incial de la ventana
const int W_HEIGHT = 500;
GLfloat fAngulo; // Variable que indica el ngulo de rotacin de los ejes.
static GLfloat angle_aux=.1;//Angulo auxiliar
GLfloat fScale; // Variable que indica el escalamiento.
//static GLfloat scale_aux=.1;//auxiliar de escalamiento.
GLfloat move_x;
GLfloat move_y;
// Funcin que visualiza la escena OpenGL
void Display (void) {
    // Borramos la escena
    glClear (GL_COLOR_BUFFER_BIT);
    glPushMatrix();
    glTranslatef(move_x,move_y,0);
// Rotamos las proximas primitivas
    glRotatef (fAngulo, 0.0f, 0.0f, 1.0f);
    glScalef(.5,.5,.5);
// Creamos a continuacin dibujamos los tres poligonos
    glBegin (GL_POLYGON);
    glColor3f (1.0f, 1.0f, 1.0f);
    glVertex3f(0.0f, 0.0f, 0.0f);
    glColor3f (0.0f, 1.0f, 0.0f);
    glVertex3f(1.0f, 0.0f, 0.0f);
    glColor3f (0.0f, 1.0f, 0.0f);
    glVertex3f(-0.5f, 0.866f, 0.0f);
    glEnd();

    glBegin (GL_POLYGON);
    glColor3f (1.0f, 1.0f, 1.0f);
    glVertex3f(0.0f, 0.0f, 0.0f);
    glColor3f (1.0f, 0.0f, 0.0f);
    glVertex3f(1.0f, 0.0f, 0.0f);
    glColor3f (0.0f, 0.0f, 1.0f);
    glVertex3f(-0.5f, -0.866f, 0.0f);
    glEnd();

    glBegin (GL_POLYGON);
    glColor3f (1.0f, 1.0f, 1.0f);
    glVertex3f(0.0f, 0.0f, 0.0f);
    glColor3f (0.0f, 1.0f, 1.0f);
    glVertex3f(-0.5f, 0.866f, 0.0f);
    glColor3f (0.0f, 0.0f, 1.0f);
    glVertex3f(-0.5f, -0.866f, 0.0f);
    glEnd();
    //pinto unos puntos que quien sabe si veran :p
    glColor3d(1,0,0);
    glBegin(GL_POINTS);
    glVertex2f(0.0, 0.0);
    glVertex2f(0.0, 1.0);
    glVertex2f(1.0, 0.2);
    glVertex2f(0.5, 0.1);
    glVertex2f(-0.2, 1.4);
    glEnd();
    glPopMatrix();

    glFlush();//para cuando utilizamos un unico buffer
    //glutSwapBuffers();//para cuando utilizamos doble buffer
}

// Funcin que se ejecuta cuando el sistema no esta ocupado
void Idle (void) {
// Incrementamos el ngulo
    fAngulo += angle_aux;
// Si es mayor que dos pi la decrementamos
    if (fAngulo > 360)
        fAngulo -= 360;
    if (fAngulo < 0.0)
        fAngulo = 360;
// Indicamos que es necesario repintar la pantalla
    glutPostRedisplay();
//Aqui imprimo el valor del angulo en cada momento
    cout << fAngulo << endl;
}
//Esta funcion se encarga de Manejar el teclado
static void key(unsigned char key, int x, int y){
    switch (key){
        case 27 :
        case 'q':
            exit(0);
            break;
        case '+':
            if(fAngulo < 360)
                angle_aux+=.1;
            break;
        case '-':
            if(fAngulo > 0)
                angle_aux-=.1;
            break;
        case 'd':
            move_x+=.1;
            if(move_x>2)
                move_x=-1;
            break;
        case 'a':
            move_x-=.1;
            if(move_x<-2)
                move_x=1;
            break;
        case 'w':
                move_y+=.1;
            break;
        case 's':
                move_y-=.1;
            break;
    }
    glutPostRedisplay();
}
//Esta funcion se encarga de Manejar teclas especiales en el teclado
void SpecialKeys(int key, int x, int y){
    switch (key){
        case GLUT_KEY_RIGHT:
            move_x+=.1;
            if(move_x>2)
                move_x=-1;
            break;
        case GLUT_KEY_LEFT:
            move_x-=.1;
            if(move_x<-2)
                move_x=1;
            break;
        case GLUT_KEY_UP:
                move_y+=.1;
                if(move_y>2)
                    move_y=-1;
            break;
        case GLUT_KEY_DOWN:
                move_y-=.1;
                if(move_y<-2)
                    move_y=1;
            break;
        case GLUT_KEY_F1:
            glClearColor (1.0f, 0.0f, 0.0f, 1.0f);
            break;
        case GLUT_KEY_F2:
            glClearColor (1.0f, 1.0f, 1.0f, 1.0f);
            break;
    }
    glutPostRedisplay();
}

// Funcin principal
int main(int argc, char **argv) {
// Inicializamos la librera GLUT
    glutInit (&argc, argv);
// Indicamos como ha de ser la nueva ventana
    glutInitWindowPosition (100,100);
    glutInitWindowSize (W_WIDTH, W_HEIGHT);
//Aqui solo utilizamos un solo buffer por eso se ve parpadear
    glutInitDisplayMode (GLUT_RGBA | GLUT_SINGLE);
//Aqui utilizamos un doble buffer por eso no se ve parpadear
    //glutInitDisplayMode (GLUT_RGBA | GLUT_DOUBLE);
// Creamos la nueva ventana
    glutCreateWindow ("Mi primer Juego en OpenGL");
// Indicamos cuales son las funciones de redibujado e idle
    glutDisplayFunc(Display);
    glutIdleFunc(Idle);
    glutKeyboardFunc(key);
    glutSpecialFunc(SpecialKeys);
// El color de fondo ser el negro (RGBA, RGB + Alpha channel)
    glClearColor (1.0f, 1.0f, 1.0f, 1.0f);
    glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
    glOrtho (-1.0, 1.0f, -1.0, 1.0f, -1.0, 1.0f);
    glMatrixMode(GL_MODELVIEW);
// Comienza la ejecucin del core de GLUT
    glutMainLoop();
    return 0;
}
